import { useQuery } from "@tanstack/react-query";
import { silencedMock } from "@qltr/mocks/alerting-mock.js";
import { failingMock } from "@qltr/mocks/results-mock.js";
import { testsMock, mappingsMock } from "@qltr/mocks/catalog-mock.js";

const QUALITEER_URL = "https://qualiteer.elijahparker3.repl.co/api";

const useMock = true;

const asMock = (data) => ({ data });

const fetchApi = (subPath) => async () =>
  fetch(`${QUALITEER_URL}${subPath}`).then((res) => res.json());

export const useCatalogTests = () =>
  useMock
    ? asMock(testsMock())
    : useQuery(["catalogTests"], fetchApi("/catalog/tests"));

export const usePipelineMappings = () =>
  useMock
    ? asMock(mappingsMock())
    : useQuery(["pipelineMappings"], fetchApi("/catalog/pipeline-mappings"));

export const useSilencedAlerts = () =>
  useMock
    ? asMock(silencedMock())
    : useQuery(["silenced"], fetchApi("/alerting/silenced"));

export const useCurrentlyFailing = () =>
  useMock
    ? asMock(failingMock())
    : useQuery(["failing"], fetchApi("/results/failing"));
